// http://www.cactus.org/~nystrom/startrek.html 内の Hereから
// とりあえず移植はしたけど、やり方をすっかり忘れているので動作検証はしてません。
// また、(桁合わせとかが)面倒なので、ほとんど日本語化してません。
// 用語など、スタートレックゲーム全般についてはWikipediaのここ↓参照のこと。
// https://ja.wikipedia.org/wiki/%E3%82%B9%E3%82%BF%E3%83%BC%E3%83%88%E3%83%AC%E3%83%83%E3%82%AF_(%E3%83%9E%E3%82%A4%E3%82%B3%E3%83%B3%E3%82%B2%E3%83%BC%E3%83%A0)
//
// startrek.c
// 
// Super Star Trek Classic (v1.1)
// Retro Star Trek Game 
// C Port Copyright (C) 1996  <Chris Nystrom>
// 
// This program is free software; you can redistribute it and/or modify
// in any way that you wish. _Star Trek_ is a trademark of Paramount
// I think.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
// 
// This is a C port of an old BASIC program: the classic Super Star Trek
// game. It comes from the book _BASIC Computer Games_ edited by David Ahl
// of Creative Computing fame. It was published in 1978 by Workman Publishing,
// 1 West 39 Street, New York, New York, and the ISBN is: 0-89489-052-3.
// 
// See http://www.cactus.org/~nystrom/startrek.html for more info.
// 
// Contact Author of C port at:
// 
// Chris Nystrom
// 1013 Prairie Dove Circle
// Austin, Texas  78758
// 
// E-Mail: cnystrom@gmail.com, nystrom@cactus.org
// 
// BASIC -> Conversion Issues
// 
//     - String Names changed from A$ to sA$
//     - Arrays changed from G(8,8) to g(9,9) so indexes can
//       stay the same.
// 
// Here is the original BASIC header:
// 
// SUPER STARTREK - MAY 16, 1978 - REQUIRES 24K MEMORY
// 
//         **** STAR TREK ****        ****
//  SIMULATION OF A MISSION OF THE STARSHIP ENTERPRISE,
//  AS SEEN ON THE STAR TREK TV SHOW.
//  ORIGINAL PROGRAM BY MIKE MAYFIELD, MODIFIED VERSION
//  PUBLISHED IN DEC'S "101 BASIC GAMES", BY DAVE AHL.
//  MODIFICATIONS TO THE LATTER (PLUS DEBUGGING) BY BOB
//  LEEDOM - APRIL & DECEMBER 1974,
//  WITH A LITTLE HELP FROM HIS FRIENDS . . .
//  COMMENTS, EPITHETS, AND SUGGESTIONS SOLICITED --
//  SEND TO:  R. C. LEEDOM
//            WESTINGHOUSE DEFENSE & ELECTRONICS SYSTEMS CNTR.
//            BOX 746, M.S. 338
//            BALTIMORE, MD  21203
// 
//  CONVERTED TO MICROSOFT 8 K BASIC 3/16/78 BY JOHN BORDERS
//  LINE NUMBERS FROM VERSION STREK7 OF 1/12/75 PRESERVED AS
//  MUCH AS POSSIBLE WHILE USING MULTIPLE STATMENTS PER LINE
//
// 全機種対応

if maxStringLength()<255 then {
	print "Please set max string length>=255."
	end
}

// Standard Line Length
int MAXLEN=255
 
// Standard Terminal Sizes
int MAXROW =24
int MAXCOL =80
 
// Standard Page Size
int MAXLINES=66

// Global Variables
int b3		//  Starbases in Quadrant 
int b4, b5	//  Starbase Location in sector 
int b9		//  Total Starbases 

dim int c(3,10) = { // Used for location and movement
	 0, 0,  0,  0,  0,  0,  0, 0, 0, 0 ,
	 0, 0, -1, -1, -1,  0,  1, 1, 1, 0 ,
	 1, 1,  1,  0, -1, -1, -1, 0, 1, 1 
}

int d0			://  Docked flag
int d1			://  Damage Repair Flag
int e			://  Current Energy
int e0 = 3000	://  Starting Energy
dim int g(9,9)	://  Galaxy
int g5			://  Quadrant name flag
dim int k(4,4)	://  Klingon Data
int k3			://  Klingons in Quadrant
int k7			://  Klingons at start
int k9			://  Total Klingons left
int n			://  Number of secors to travel
int p			://  Photon Torpedoes left
int p0 = 10		://  Photon Torpedo capacity
int q1, q2		://  Quadrant Position of Enterprise
int r1, r2		://  Temporary Location Corrdinates
int s			://  Current shield value
int s3			://  Stars in quadrant
int s8			://  Quadrant locating index
int s9 = 200	://  Klingon Power
int t0			://  Starting Stardate
int t9			://  End of time
dim int z(9,9)	://  Cumulative Record of Galaxy
int z3			://  string_compare return value
int z1, z2		://  Temporary Sector Coordinates
int z4, z5		://  Temporary quadrant coordinates

float a, c1		://  Used by Library Computer
dim float d(9)	://  Damage Array
float d4		://  Used for computing damage repair time
float s1, s2	://  Current Sector Position of Enterprise
float t			://  Current Stardate
float w1		://  Warp Factor
float x, y, x1, x2	://  Navigational coordinates

str sA$			://  An Object in a Sector
str sC$			://  Condition
str sQ$			://  Visual Display of Quadrant : 最大文字列長を256以上に設定すること
str sG2$		://  Used to pass string results 

//
// 画面初期化 / screen initialize
enum
	// 数字＝'0'〜'9'、'.'と重ならないようにする
	CR=&h0d
	BS=&h09
	ESC=&h1b
endenum
font("IPAGothic")
int fzenhan
int WX=64://if deviceType()<>1 then WX=48
int WY=width(WX,,fzenhan)
int xw=1:/* 全角１文字の桁数 / double-width 1 character's columus
if fzenhan then xw=2
dim int	touchNo(15)	:// タッチエリア番号 / touch area number
int touchallcnt		:// タッチエリア数   / the number of touch area

// Main Program
	intro()
	new_game()
	end

//----------------------------------------------------------------

func intro()
	print
	print
	print " *************************************"
	print " *                                   *"
	print " *                                   *"
	print " *      * * Super Star Trek * *      *"
	print " *                                   *"
	print " *                                   *"
	print " *************************************"
	int i
	for i=1 to 3
		print
	next
	print "                         ------*------"
	print "         -------------   `---  ------'"
	print "         `-------- --'      / /"
	print "                  ''''-------  --"
	print "                  '-----------'"
	print
	print "       The USS Enterprise --- NCC - 1701"
	print
	print
	//
	randomize2()
	t = (get_rand(20) + 20) * 100
endfunc

func new_game()
	str sTemp

	initialize()
	new_quadrant()
	short_range_scan()

	while 1
		if (s + e <= 10 and (e < 10 or d(7) < 0)) then {
			print
			print "** Fatal Error **   ";
			print "You've just stranded your ship in space."
			print
			print "You have insufficient maneuvering energy, and Shield Control is presently";
			print "incapable of cross circuiting to engine room!!"
			print
			end_of_time()
		}
		setFunctionKey(0,"nav",'n')
		setFunctionKey(1,"srs",'d')
		setFunctionKey(2,"lrs",'l')
		setFunctionKey(3,"pha",'p')
		setFunctionKey(4,"tor",'t')
		setFunctionKey(5,"she",'S')
		setFunctionKey(6,"dam",'d')
		setFunctionKey(7,"com",'c')
		setFunctionKey(8,"xxx",'x')
		setFunctionKey(9,"help",'h')
		setFunctionKeyBackgroundImage("funcBackG1.png")
		displayFunctionKeyAll(YES,YES)

		print "Select command:"
		print "  nav - To Set Course"
		print "  srs - Short Range Sensors","  lrs - Long Range Sensors"
		print "  pha - Phasers            ","  tor - Photon Torpedoes"
		print "  she - Sheild Control     ","  dam - Damage Control"
		print "  com - Library Computer   ","  xxx - Resign Commision"
		printWithScrollUp()

		repeat
			int ky=inkey()
		until ky<>0
		displayFunctionKeyAll(NO,YES)

		switch ky
			case 'n'
				course_control()
				break
			case 's'
				short_range_scan()
				break
			case 'l'
				long_range_scan()
				break
			case 'p'
				phaser_control()
				break
			case 't'
				photon_torpedoes()
				break
			case 'S'
				sheild_control()
				break
			case 'd'
				damage_control()
				break
			case 'c'
				library_computer()
				break
			case 'x'
				resign_commision()
				break
			case 'h'
				help()
				short_range_scan()
				break
			case 'e'
				end
		endswitch
	endwhile
endfunc

func help():// 追加
cls()
print "1. When you see Command? printed, enter one of the legal commands";
print "(nav, srs, lrs, pha, tor, she, dam, com, hlp, end, or xxx)."
print
print "2. If you should type in an illegal command, you'll get a short list of";
print "the legal commands printed out."
print "
print "3. Some commands require you to enter data (for example, the 'nav' command";
print "comes back with 'Course(1-9) ?'.) If you type in illegal data (like";
print "negative numbers), that command will be aborted."
print
print "The galaxy is divided into an 8 X 8 quadrant grid, and each quadrant";
print "is further divided into an 8 x 8 sector grid."
print
print "You will be assigned a starting point somewhere in the galaxy to begin";
print "a tour of duty as commander of the starship _Enterprise_; your mission:";
print "to seek out and destroy the fleet of Klingon warships which are menacing";
print "the United Federation of Planets."
print
hitKey()
print "You have the following commands available to you as Captain of the Starship ";
print "Enterprise:"
print
print "'nav' Command = Warp Engine Control --"
print
print "Course is in a circular numerical vector            4  3  2"
print "arrangement as shown. Integer and real               . . ."
print "values may be used. (Thus course 1.5 is               ..."
print "half-way between 1 and 2.                         5 ---*--- 1"
print "                                                      ..."
print "Values may approach 9.0, which itself is             . . ."
print "equivalent to 1.0.                                  6  7  8"
print
print "One warp factor is the size of one quadrant.        COURSE"
print "Therefore, to get from quadrant 6,5 to 5,5"
print "you would use course 3, warp factor 1."
print
print "'srs' Command = Short Range Sensor Scan"
print
print
print "Shows you a scan of your present quadrant."
print
print "Symbology on your sensor screen is as follows:"
print "<*> = Your starship's position"
print "+K+ = Klingon battlecruiser"
print ">!< = Federation starbase (Refuel/Repair/Re-Arm here)"
print " *  = Star"
print
print "A condensed 'Status Report' will also be presented."
print
hitKey()
print "'lrs' Command = Long Range Sensor Scan"
print
print "Shows conditions in space for one quadrant on each side of the Enterprise";
print "(which is in the middle of the scan). The scan is coded in the form '###'";
print "where the units digit is the number of stars, the tens digit is the number";
print "of starbases, and the hundreds digit is the number of Klingons."
print
print "Example - 207 = 2 Klingons, No Starbases, & 7 stars."
print
print
print "'pha' Command = Phaser Control."
print
print "Allows you to destroy the Klingon Battle Cruisers by zapping them with";
print "suitably large units of energy to deplete their shield power. (Remember,";
print "Klingons have phasers, too!)"
print
print
print "'tor' Command = Photon Torpedo Control"
print
print "Torpedo course is the same  as used in warp engine control. If you hit";
print "the Klingon vessel, he is destroyed and cannot fire back at you. If you";
print "miss, you are subject to the phaser fire of all other Klingons in the";
print "quadrant."
print "The Library-Computer ('com' command) has an option to compute torpedo";
print "trajectory for you (option 2)."
print
print
print "'she' Command = Shield Control"
print
print "Defines the number of energy units to be assigned to the shields. Energy";
print "is taken from total ship's energy. Note that the status display total";
print "energy includes shield energy."
print
print
hitKey()
print "'dam' Command = Damage Control report"
print "Gives the state of repair of all devices. Where a negative 'State of Repair'";
print "shows that the device is temporarily damaged."
print
print
print "'com' Command = Library-Computer"
print "The Library-Computer contains six options:"
print
print "Option 0 = Cumulative Galactic Record"
print "This option shows computer memory of the results of all previous";
print "short and long range sensor scans."
print
print "Option 1 = Status Report"
print "This option shows the number of Klingons, stardates, and starbases";
print "remaining in the game."
print
print "Option 2 = Photon Torpedo Data"
print "Which gives directions and distance from Enterprise to all Klingons";
print "in your quadrant."
print
print "Option 3 = Starbase Nav Data"
print "This option gives direction and distance to any starbase in your";
print "quadrant."
print
print "Option 4 = Direction/Distance Calculator"
print "This option allows you to enter coordinates for direction/distance";
print "calculations."
print
print "Option 5 = Galactic /Region Name/ Map"
print "This option prints the names of the sixteen major galactic regions";
print "referred to in the game."
hitKey(YES)
endfunc

func initialize()
	int i, j
	str sX$  = ""
	str sX0$ = "is"

	// InItialize time
	t0 = int(t)
	t9 = 25 + get_rand(10)

	// Initialize Enterprise
	d0 = 0
	e = e0
	p = p0
	s = 0

	q1 = function_r()
	q2 = function_r()
	s1 = function_r():// float
	s2 = function_r():// float

	for i=1 to 8
		d(i) = 0.0
	next

	// Setup What Exists in Galaxy
	for i=1 to 8
		for j=1 to 8
			k3 = 0
			z(i,j) = 0
			r1 = get_rand(100)
			if (r1 > 98) then {
				k3 = 3
			} else {
				if (r1 > 95) then {
					k3 = 2
				} else {
					if (r1 > 80) then k3 = 1
				}
			}
			k9 = k9 + k3
			b3 = 0
			if (get_rand(100) > 96) then b3 = 1
			b9 = b9 + b3
			g(i,j) = k3 * 100 + b3 * 10 + function_r()
		next
	next

	if (k9 > t9) then t9 = k9 + 1

	if b9 = 0 then {
		if g(q1,q2) < 200 then {
			g(q1,q2) = g(q1,q2) + 100
			k9=k9+1
		}
		g(q1,q2) = g(q1,q2) + 10
		b9=b9+1
		q1 = function_r()
		q2 = function_r()
	}
	k7 = k9
	if b9 <> 1 then {
		sX$ = "s"
		sX0$= "are"
	}

	print
	print "Your orders are as follows:"
	print
	print "   Destroy the";k9;" Klingon warships which have invaded"
	print " the galaxy before they can attack Federation Headquarters"
	print " on stardate";t0 + t9;". This gives you";t9;" days. There ";sX0$
	print b9;" starbase";sX$;" in the galaxy for resupplying your ship."
	printWithScrollUp()
//	print "Hit any key to accept command. ";
	hitKey(YES,"命令を受諾するならここをタップしなさい","Tap here to accept command.")
endfunc

func new_quadrant()
	int i

	z4 = q1
	z5 = q2
	k3 = 0
	b3 = 0
	s3 = 0
	g5 = 0 
	d4 = get_rand(100)
	d4 = d4 / 100 / 50
	z(q1,q2) = g(q1,q2)

	if q1 >= 1 and q1 <= 8 and q2 >= 1 and q2 <= 8 then {
		quadrant_name()
		if (t0 <> t) then {
			print "Now entering ";sG2$;" quadrant..."
		} else {
			print
			print "Your mission begins with your starship located"
			print "in the galactic quadrant ";sG2$;"."
		}
		print
	}

	k3 = int(g(q1,q2) * 0.01)
	b3 = int(g(q1,q2) * 0.1 - 10 * k3)
	s3 = g(q1,q2) - 100 * k3 - 10 * b3

	if k3 > 0 then {
		print "Combat Area  Condition Red"
		if (s < 200) then print "Shields Dangerously Low"
	}

	for i=1 to 3
		k(i,1) = 0
		k(i,2) = 0
		k(i,3) = 0
	next
	sQ$=space$(24*8+1):// =193 [0]～[192],[193]=EOS

	// Position Enterprise, then Klingons, Starbases, and stars
	sA$= "<*>"
	z1 = int(s1)	:// z1 = cint(s1)
	z2 = int(s2)	:// z2 = cint(s2)
	insert_in_quadrant()

	if k3 > 0 then {
		for i = 1 to k3
			find_empty_place()
			sA$= "+K+"
			z1 = r1
			z2 = r2
			insert_in_quadrant()
			k(i,1) = r1
			k(i,2) = r2
			k(i,3) = 100 + get_rand(200)
		next
	}

	if b3 > 0 then {
		find_empty_place()
		sA$= ">!<"
		z1 = r1
		z2 = r2
		insert_in_quadrant()
		b4 = r1
		b5 = r2
	}

	for i = 1 to s3
		find_empty_place()
		sA$= " * "
		z1 = r1
		z2 = r2
		insert_in_quadrant()
	next
endfunc

func course_control()
	int i
	int q4, q5
	str sTemp
	float c1
	str sX$ = "8"

	c1=inputNumber("Course (0.0-9.0): ")
//	input "Course (0.0-9.0): ",c1
//	c1 = atof(sTemp)
	if (c1 = 9.0) then c1 = 1.0
	if (c1 < 0.0 or c1 > 9.0) then {
		print "Lt. Sulu reports:"
		print "  Incorrect course data, sir!"
		print
		return
	}

	if (d(1) < 0.0) then sX$= "0.2"

	w1=inputNumber("Warp Factor (0-"+sX$+"): ")
//	print "Warp Factor (0-";sX$;"): ";
//	input sTemp
//	w1 = atof(sTemp)
	if d(1) < 0.0 and w1 > 0.21 then {
		print "Warp Engines are damaged. "
		print "Maximum speed = Warp 0.2."
		print
		return
	}

	if (w1 <= 0.0) then return
	if w1 > 8.1 then {
		print "Chief Engineer Scott reports:"
		print using "  The engines won't take warp ####.#_!", w1
		print
		return
	}

	n = cint(w1 * 8.0) :// @@@ note: this is a real round in the original basic
  
	if e - n < 0 then {
		print "Engineering reports:"
		print "  Insufficient energy available for maneuvering";
		print using " at warp ####.#_!",w1
		print

		if s >= n and d(7) >= 0.0 then {
			print "Deflector Control Room acknowledges:"
			print " ";s;" units of energy presently deployed to shields."
		}
		return
	}

	klingons_move()
	repair_damage()

	sA$= "   "
	z1 = int(s1)	:// @@@ z1 = cint(s1)
	z2 = int(s2)	:// @@@ z2 = cint(s2)
	insert_in_quadrant()

	// @@@ c2 = cint(c1)
	// @@@ c3 = c2 + 1;
	// @@@ x1 = c(0,c2) + (c(0,c3) - c(0,c2)) * (c1 - c2)
	// @@@ x2 = c(1,c2) + (c(1,c3) - c(1,c2)) * (c1 - c2)
	x1 = c(1,int(c1)) + (c(1,int(c1) + 1) - c(1,int(c1))) * (c1 - int(c1))
	x2 = c(2,int(c1)) + (c(2,int(c1) + 1) - c(2,int(c1))) * (c1 - int(c1))

	x = s1
	y = s2
	q4 = q1
	q5 = q2

	for i=1 to n
		s1 = s1 + x1
		s2 = s2 + x2

		z1 = int(s1)	:// @@@ z1 = cint(s1)
		z2 = int(s2)	:// @@@ z2 = cint(s2)

		if (z1 < 1 or z1 >= 9 or z2 < 1 or z2 >= 9) then {
			exceed_quadrant_limits()
			complete_maneuver()
			return
		}
		string_compare()
		if z3 <> 1 then { // Sector not empty
			s1 = s1 - x1
			s2 = s2 - x2
			print "Warp Engines shut down at sector";z1;",";z2;" due to bad navigation."
			print
			i = n + 1
		}
	next
	complete_maneuver()
endfunc


func complete_maneuver()
	float t8

	sA$= "<*>"
	z1 = int(s1)	:// @@@ z1 = cint(s1)
	z2 = int(s2)	:// @@@ z2 = cint(s2)
	insert_in_quadrant()
	maneuver_energy()
	
	t8 = 1.0
	if (w1 < 1.0) then t8 = w1
	t = t + t8
	if (t > t0 + t9) then end_of_time()
	
	short_range_scan()
endfunc


func exceed_quadrant_limits()
	int x5 = 0	://  Outside galaxy flag 

	x = (8 * q1) + x + (n * x1)
	y = (8 * q2) + y + (n * x2)
	q1 = int(x / 8.0)
	q2 = int(y / 8.0)
	s1 = x - (q1 * 8)
	s2 = y - (q2 * 8)

	// @@@ if (cint(s1) = 0)
	if int(s1) = 0 then {
		q1 = q1 - 1
		s1 = s1 + 8.0
	}

	// @@@ if (cint(s2) = 0)
	if int(s2) = 0 then {
		q2 = q2 - 1
		s2 = s2 + 8.0
	}

	// check if outside galaxy
	if q1 < 1 then {
		x5 = 1
		q1 = 1
		s1 = 1.0
	}
	if q1 > 8 then {
		x5 = 1
		q1 = 8
		s1 = 8.0
	}
	if q2 < 1 then {
		x5 = 1
		q2 = 1
		s2 = 1.0
	}
	if q2 > 8 then {
		x5 = 1
		q2 = 8
		s2 = 8.0
	}

	if x5 = 1 then {
		print "LT. Uhura reports:"
		print "  Message from Starfleet Command:"
		print
		print "  Permission to attempt crossing of galactic perimeter"
		print "  is hereby *denied*. Shut down your engines."
		print
		print "Chief Engineer Scott reports:"
		print "  Warp Engines shut down at sector ";int(s1);", ";	:// cint(s1)
		print int(s2);" of quadrant ";q1;",";q2;"."					:// cint(s2)
		print
	}
	maneuver_energy()

	if (t > t0 + t9) then end_of_time()
	t = t + 1
	new_quadrant()
endfunc

func maneuver_energy()
	e = e - n - 10
	if (e >= 0) then return

	print "Shield Control supplies energy to complete maneuver."
	print

	s = s + e
	e = 0

	if (s <= 0) then s = 0
endfunc

func short_range_scan()
	int i, j

	sC$= "GREEN"
	if (e < e0 * 0.1) then sC$= "YELLOW"
	if (k3 > 0) then sC$= "*RED*"

	d0 = 0
	for i = int(s1 - 1) to int(s1 + 1)
		for j = int(s2 - 1) to int(s2 + 1)
			if i >= 1 and i <= 8 and j >= 1 and j <= 8 then {
				sA$= ">!<"
				z1 = i
				z2 = j
				string_compare()
				if z3 = 1 then {
					d0 = 1
					sC$= "DOCKED"
					e = e0
					p = p0
					print "Shields dropped for docking purposes."
					s = 0
				}
			}
		next
	next
	if d(2) < 0.0 then {
		print
		print "*** Short Range Sensors are out ***"
		return
	}

	print "------------------------"

	for i=0 to 8-1
		for j=0 to 24-1
			print mid$(sQ$,i*24+j+1,1);
		next

		switch i
			case 0
				print "    Stardate..........."; int(t)
				break
			case 1
				print "    Condition.......... "; sC$
				break
			case 2
				print "    Quadrant...........";q1;",";q2
				break
			case 3
				print "    Sector.............";int(s1);",";int(s2)	:// cint(s1),cint(s2)
				break
			case 4
				print "    Photon Torpedoes...";p
				break
			case 5
				print "    Total Energy.......";e+s
				break
			case 6
				print "    Shields............";s
				break
			case 7
				print "    Klingons Remaining.";k9
				break
		endswitch
	next
	print "------------------------"
	print
endfunc

func long_range_scan()
	int i, j

	if d(3) < 0.0 then {
		print "Long Range Sensors are inoperable."
		return
	}
	print "Long Range Scan for Quadrant";q1;",";q2
	print

	for i = q1 - 1 to q1 + 1
		print "--------------------"
		print ":"
		for j = q2 - 1 to  q2 + 1
			if i > 0 and i <= 8 and j > 0 and j <= 8 then {
				z(i,j) = g(i,j)
			  	print using " ###.### :", z(i,j);
			} else {
				print " *** :";
			}
		next
		print
	next
	print "--------------------"
	print
endfunc

func phaser_control()
	int i
	int iEnergy
	int h1, h
	str sTemp

	if d(4) < 0.0 then {
		print "Phasers Inoperative"
		print
		return
	}

	if k3 <= 0 then {
		print "Science Officer Spock reports:"
		print "  'Sensors show no enemy ships in this quadrant'"
		print
		return
	}

	if (d(8) < 0.0) then {
		print "Computer failure hampers accuracy."
	}
	print "Phasers locked on target:"
	print "Energy available =";e;" units"
	print
	
	iEnergy=inputNumber("Number of units to fire: ")
//	input "Number of units to fire: ",sTemp
//	iEnergy = atoi(sTemp)
	if (iEnergy <= 0) then return
	if e - iEnergy < 0 then {
		print "Not enough energy available."
		print
		return
	}
	e = e - iEnergy

	if d(8) < 0.0 then {
		iEnergy = int(iEnergy * rnd()):// @@@ iEnergy = iEnergy * rnd()
	}
	h1 = iEnergy / k3

	for i=1 to 3
		if k(i,3) > 0 then {
			h = int(h1 / function_d(0) * (rnd() + 2))
			if h <= 0.15 * k(i,3) then {
				print "Sensors show no damage to enemy at ";k(i,1);",";k(i,2)
			} else {
				k(i,3) = k(i,3) - h
				print h;" unit hit on Klingon at sector ";k(i,1);",";k(i,2)
				if k(i,3) <= 0 then {
					print "*** Klingon Destroyed ***"
					print
					k3=k3-1
					k9=k9-1
					z1 = k(i,1)
					z2 = k(i,2)
					sA$= "   "
					insert_in_quadrant()
					k(i,3) = 0
					g(q1,q2) = g(q1,q2) - 100
					z(q1,q2) = g(q1,q2)
					if (k9 <= 0) then won_game()
				} else {
					print "   (Sensors show";k(i,3);" units remaining.)"
					print
				}
			}
		}
	next
	klingons_shoot()
endfunc

func photon_torpedoes()
	int x3, y3, x5
	str sTemp
	float c1

	if p <= 0 then {
		print "All photon torpedoes expended"
		return
	}
	if d(5) < 0.0 then {
		print "Photon Tubes not operational"
		return
	}

	c1=inputNumber("Course (0-9): ")
//	input "Course (0-9): ",sTemp
//	c1 = atof(sTemp)
	if (c1 = 9.0) then c1 = 1.0

	if (c1 < 1.0 or c1 > 9.0) then {
		print "Ensign Chekov roports:"
		print "  Incorrect course data, sir!"
		print
		return
	}

	e = e - 2
	p = p-1

	// @@@ c2 = cint(c1)
	// @@@ c3 = c2 + 1;
	// @@@ x1 = c(0,c2) + (c(0,c3) - c(0,c2)) * (c1 - c2)
	// @@@ x2 = c(1,c2) + (c(1,c3) - c(1,c2)) * (c1 - c2)
	x1 = c(1,int(c1)) + (c(1,int(c1) + 1) - c(1,int(c1))) * (c1 - int(c1))
	x2 = c(2,int(c1)) + (c(2,int(c1) + 1) - c(2,int(c1))) * (c1 - int(c1))

	x = s1 + x1
	y = s2 + x2
	x3 = cint(x) :// @@@ note: this is a true integer round in the MS BASIC version
	y3 = cint(y) :// @@@ note: this is a true integer round in the MS BASIC version
	x5 = 0

	print "Torpedo Track:"

	while (x3 >= 1 and x3 <= 8 and y3 >= 1 and y3 <= 8)
		print "    ";x3;",";y3

		sA$= "   "
		z1 = x3
		z2 = y3

		string_compare()

		if z3 = 0 then {
			torpedo_hit()
			klingons_shoot()
			return
		}

		x = x + x1
		y = y + x2
		x3 = cint(x) :// @@@ note: this is a true integer round in the MS BASIC version
		y3 = cint(y) :// @@@ note: this is a true integer round in the MS BASIC version
	endwhile

	print "Torpedo Missed"
	print
	klingons_shoot()
endfunc

func torpedo_hit()
	int	i, x3, y3

	x3 = cint(x) :// @@@ note: this is a true integer round in the MS BASIC version
	y3 = cint(y) :// @@@ note: this is a true integer round in the MS BASIC version
	z3 = 0

	sA$= " * "
	string_compare()

	if z3 = 1 then {
		print "Star at";x3;",";y3;" absorbed torpedo energy."
		print
		return
	}

	sA$= "+K+"
	string_compare()

	if z3 = 1 then {
		print "*** Klingon Destroyed ***"
		print
		k3=k3-1
		k9=k9-1
		if (k9 <= 0) then won_game()

		for i=0 to 3
			if (x3 = k(i,1) and y3 = k(i,2)) then {
				k(i,3) = 0
			}
		next
	}

	sA$= ">!<"
	string_compare()

	if z3 = 1 then {
		print "*** Starbase Destroyed ***"
		b3=b3-1
		b9=b9-1
		if b9 <= 0 and k9 <= t - t0 - t9 then {
			print "That does it, Captain!!";
			print "You are hereby relieved of command"
			print "and sentanced to 99 stardates of hard labor on Cygnus 12!!"
			resign_commision()
		}
		print "Starfleet Command reviewing your record to consider"
		print "court martial!"
		print
		d0 = 0		://  Undock 
	}

	z1 = x3
	z2 = y3
	sA$="   "
	insert_in_quadrant()
	
	g(q1,q2) = (k3 * 100) + (b3 * 10) + s3
	z(q1,q2) = g(q1,q2)
endfunc

func damage_control()
	int a1
	float d3 = 0.0
	int i

	if d(6) < 0.0 then {
		print "Damage Control report not available."

		if (d0 = 0) then return

		d3 = 0.0
		for i=1 to 8
			if (d(i) < 0.0) then d3 = d3 + 0.1
		next
		if (d3 = 0.0) then return

		d3 = d3 + d4
		if (d3 >= 1.0) then d3 = 0.9

		print
		print "Technicians standing by to effect repairs to your ship;"
		print "Estimated time to repair: ";
		print using "####.## stardates.",d3

		dim str menues(2)={"YES","NO"}
		a1=selectMenu2("Will you authorize the repair order ?",menues)

		if (a1 = 0) then {
			for i=1 to 8
				if (d(i) < 0.0) then d(i) = 0.0
			next
			t = t + d3 + 0.1
		}
	}

	print "Device            State of Repair"

	for r1 = 1 to 8
		get_device_name()
		print sG2$;
		for i = 1 to 25 - strlen(sG2$)-1
			print " ";
		next
		print using "####.##",d(r1)
	next
	print
endfunc 

func sheild_control()
	int i
	str sTemp

	if d(7) < 0.0 then {
		print "Sheild Control inoperable"
		return
	}

	print "Energy available = ";e + s
	print

	i=inputNumber("Input number of units to shields: ")
//	input "Input number of units to shields: ",sTemp
//	i = atoi(sTemp)
	if (i < 0 or s = i) then {
		print "<Sheilds Unchanged>"
		print
		return
	}
	if i >= e + s then {
		print "Sheild Control Reports:"
		print "  'This is not the Federation Treasury.'"
		print "<Sheilds Unchanged>"
		print
		return
	}
	e = e + s - i
	s = i

	print "Deflector Control Room report:"
	print "  'Shields now at";s;" units per your command.'"
	print
endfunc

func library_computer()

	if d(8) < 0.0 then {
		print "Library Computer inoperable"
		return
	}

	dim str menues(6)={"Cumulative Galactic Record","Status Report","Photon Torpedo Data","Starbase Nav Data","Direction/Distance Calculator","Galaxy 'Region Name' Map"}
	int temp=selectMenu2("Computer active and awating command",menues)
	switch temp
		case 0
			galactic_record()
			break
		case 1
			status_report()
			break
		case 2
			torpedo_data()
			break
		case 3
			nav_data()
			break
		case 4
			dirdist_calc()
			break
		case 5
			galaxy_map()
			break
	endswitch
endfunc

func galactic_record()
	int i, j

	print
	print "     Computer Record of Galaxy for Quadrant ",q1;",";q2
	print
	print "     1     2     3     4     5     6     7     8"
	for i=1 to 8
		print "   ----- ----- ----- ----- ----- ----- ----- -----"
		print i
		for j=1 to 8
			print "   ";
			if (z(i,j) = 0) then {
				print "***";
			} else {
				print using "###", z(i,j);
			}
		next
		print
	next
	print "   ----- ----- ----- ----- ----- ----- ----- -----"
	print
endfunc

func status_report()
	str sX$ = ""

	print "   Status Report:"
	print
	if (k9 > 1) then sX$= "s":// 複数形のs
	print "Klingon";sX$;" Left:", k9;
	print using "Mission must be completed in ####.# stardates",0.1 * int((t0 + t9 - t) * 10)	:// cint()

	if b9 < 1 then {
		print "Your stupidity has left you on your own in the galaxy"
		print " -- you have no starbases left!"
	} else { 
		sX$= "s"
		if (b9 < 2) then sX$= ""
		print "The Federation is maintaining";b9;" starbase";sX$;" in the galaxy"
	}
	print
endfunc

func torpedo_data()
	int i
	str sX$ = ""

	if (k3 <= 0) then {
		print "Science Officer Spock reports:"
		print "  'Sensors show no enemy ships in this quadrant.'"
		print
		return
	}
	if (k3 > 1) then sX$= "s"
 
	print "From Enterprise to Klingon battlecriuser";sX$;":"
	print

	for i=1 to 3
		if (k(i,3) > 0) then {
			w1 = k(i,1)
			x  = k(i,2)
			c1 = s1
			a  = s2
			compute_vector()
		}
	next
endfunc

func nav_data()
	if (b3 <= 0) then {
		print "Mr. Spock reports,"
		print "  'Sensors show no starbases in this quadrant.'"
		print
		return
	}
	w1 = b4
	x  = b5
	c1 = s1
	a  = s2
	compute_vector()
endfunc

func dirdist_calc()
	str sTemp

	print "Direction/Distance Calculator"
	print
	print "You are at quadrant ";q1;",";q2;" sector ";int(s1);",";int(s2)
	print
	  
	c1=inputNumber("Please enter initial X coordinate: ")
//	input "Please enter initial X coordinate: ";sTemp
//	c1 = atoi(sTemp)

	a=inputNumber("Please enter initial Y coordinate: ")
//	input "Please enter initial Y coordinate: ";sTemp
//	a = atoi(sTemp)

	w1=inputNumber("Please enter final X coordinate: ")
//	input "Please enter final X coordinate  : ";sTemp
//	w1 = atoi(sTemp)

	x=inputNumber("Please enter final Y coordinate: ")
//	input "Please enter final Y coordinate  : ";sTemp
//	x = atoi(sTemp)

	compute_vector()
endfunc

func galaxy_map()
	int i, j0

	g5 = 1

	print 
	print "                   The Galaxy"
	print
	print "    1     2     3     4     5     6     7     8"

	for i=1 to 8
		print "  ----- ----- ----- ----- ----- ----- ----- -----"
		print i;" ";
		z4 = i
		z5 = 1
		quadrant_name()

		j0 = int(11 - (strlen(sG2$) / 2))
		print space$(j0);sG2$;space$(j0);
		if (strlen(sG2$) mod 2)=0 then print " ";

		z5 = 5
		quadrant_name()

		print space$(int(12 - (strlen(sG2$) / 2)));sG2$;
		print
	next
	print "  ----- ----- ----- ----- ----- ----- ----- -----"
	print
endfunc

func compute_vector()
	x = x - a
	a = c1 - w1

	if x <= 0.0 then {
		if a > 0.0 then {
			c1 = 3.0
			sub2()
		} else {
			c1 = 5.0
			sub1()
		}
	} else {
		if a < 0.0 then {
			c1 = 7.0
			sub2()
		} else {
			c1 = 1.0
			sub1()
		}
	}
endfunc

func sub1()
	x = abs(x)
	a = abs(a)

	print "  DIRECTION = ";
	if (a <= x) then {
		print using "####.##", c1 + (a / x)
	} else {
		print using "####.##", c1 + (((a * 2) - x) / a)
	}
	print "  DISTANCE = ";
	if (x>a) then {
		print using "####.##", x
	} else {
		print using "####.##", a
	}
	print
endfunc

func sub2()
	x = abs(x)
	a = abs(a)

	print "  DIRECTION = ";
	if (a >= x) then {
		print using "####.##", c1 + (x / a)
	} else {
		print using "####.##", c1 + (((x * 2) - a) / x)
	}
	print "  DISTANCE = ";
	if (x>a) then {
		print using "####.##",x
	} else {
		print using "####.##",a
	}
	print
endfunc

func ship_destroyed()
	print "The Enterprise has been destroyed. ";
	print "The Federation will be conquered."
	print
	end_of_time()
endfunc

func end_of_time()
	print "It is stardate";int(t);"."
	print
	resign_commision()
endfunc

func resign_commision()
	print "There were";k9;" Klingon Battlecruisers left at the end of your mission."
	print
	end_of_game()
endfunc

func won_game()
	print "Congradulations, Captain!  The last Klingon Battle Cruiser"
	print "menacing the Federation has been destoyed."
	print
	if (t - t0 > 0) then {
		print using "Your efficiency rating is ####.##", 1000 * pow(k7 / (t - t0), 2)
	}
	end_of_game()
endfunc

func end_of_game()

	if b9 > 0 then {
		print "The Federation is in need of a new starship commander for a similar mission."
		dim str menues(2)={"bye","retry"}
		int ret=selectMenu("If there is a volunteer, let him step forward and enter...",menues)
		if ret=0 then end
		new_game()
	}
endfunc

func klingons_move()
	int i
	for i=1 to 3
		if k(i,3) > 0 then {
			sA$= "   "
			z1 = k(i,1)
			z2 = k(i,2)
			insert_in_quadrant()
			find_empty_place()
			k(i,1) = z1
			k(i,2) = z2
			sA$= "+K+"
			insert_in_quadrant()
		}
	next
	klingons_shoot()
endfunc

func klingons_shoot()
	int h,i

	if (k3 <= 0) then return

	if d0 <> 0 then {
		print "Starbase shields protect the Enterprise"
		print
		return
	}

	for i=1 to 3
		if k(i,3) > 0 then {
			h = int( (k(i,3) / function_d(i)) * (2 + rnd()) )
			s = s - h
			k(i,3) = int(k(i,3) / (3 + rnd()))

			print h;" unit hit on Enterprise from sector ", k(i,1);",";k(i,2)
			if s <= 0 then {
				print
				ship_destroyed()
			}
			print "    <Shields down to";s;" units>"
			print
			if h >= 20 then {
				if (rnd() <= 0.6 or (h / s) > 0.2) then {
					r1 = function_r()
					d(r1) = d(r1) - (h / s) - (0.5 * rnd())
					get_device_name()
		    		print "Damage Control reports"
		    		print "   '";sG2$;"' damaged by hit"
				}
			}
		}
	next
endfunc 

func repair_damage()
	int i
	float d6	//  Repair Factor 

	d6 = w1

	if (w1 >= 1.0) then d6 = w1 / 10

	for i=1 to 8
		if d(i) < 0.0 then {
			d(i) = d(i) + d6
			if (d(i) > -0.1 and d(i) < 0) then {
				d(i) = -0.1
			} else {
				if d(i) >= 0.0 then {
					if (d1 <> 1) then d1 = 1
					print "Damage Control report:"
					r1 = i
					get_device_name()
					print "    ";sG2$;" repair completed"
					print
			    }
			}
		}
	next

	if rnd() <= 0.2 then {
		r1 = function_r()
		if rnd() < 0.6 then {
			d(r1) = d(r1) - (rnd() * 5.0 + 1.0)
			print "Damage Control report:"
			get_device_name()
			print "    ";sG2$;" damaged"
		} else {
			d(r1) = d(r1) + (rnd() * 3.0 + 1.0)
			print "Damage Control report:"
			get_device_name()
			print "    ";sG2$;" state of repair improved"
		}
		print
	}
endfunc

// Misc Functions and Subroutines

func find_empty_place()
	repeat
		r1 = function_r()
		r2 = function_r()
		sA$= "   "
		z1 = r1
		z2 = r2
		string_compare()
	until z3 <> 0
	z3 = 0
endfunc

func insert_in_quadrant()
	int i, j = 0
	s8 = (int(z2 - 0.5) * 3) + (int(z1 - 0.5) * 24) + 1
	// 初期はsQ$=space$(192)
	for i = s8 - 1 to s8 + 1
		sQ$[i] = sA$[j]
		j=j+1
	next
endfunc

func get_device_name()
	dim str device_name(8) = {
		"", 
		"Warp Engines",
		"Short Range Sensors",
		"Long Range Sensors",
		"Phaser Control",
		"Photon Tubes",
		"Damage Control",
		"Sheild Control",
		"Library-Computer"
	}
	if (r1 < 0 or r1 > 8) then r1 = 0
	sG2$= device_name(r1)
endfunc

func string_compare()
	int i
	str sB$

	z1 = int(z1 + 0.5)
	z2 = int(z2 + 0.5)
	s8 = ((z2 - 1) * 3) + ((z1 - 1) * 24) + 1

	sB$=mid$(sQ$,s8,3)
	if sB$=sA$ then z3 = 1 else z3 = 0
endfunc

func quadrant_name()
	dim str quad_name(16) = {
		"",
		"Antares",
		"Rigel",
		"Procyon",
		"Vega",
		"Canopus",
		"Altair",
		"Sagittarius",
		"Pollux",
		"Sirius",
		"Deneb",
		"Capella",
		"Betelgeuse",
		"Aldebaran",
		"Regulus",
		"Arcturus",
		"Spica"
	}
	dim str sect_name(4) = {
		"",
		" I",
		" II",
		" III",
		" IV"
	}
	if (z4 < 1 or z4 > 8 or z5 < 1 or z5 > 8) then sG2$= "Unknown"

	if (z5 <= 4) then {
		sG2$= quad_name(z4)
	} else {
		sG2$= quad_name(z4+8)
	}
	if g5 <> 1 then {
		if (z5 > 4) then z5 = z5 - 4
		sG2$=sG2$+sect_name(z5)
	}
endfunc

func int function_d(i;int)
	return(int( sqr( pow((k(i,1) - s1), 2) + pow((k(i,2) - s2), 2) ) ) )
endfunc

func int function_r()
	return(get_rand(8))
endfunc

// Round off floating point numbers instead of truncating

func int cint(d;float)
// 四捨五入
	return (int(d + 0.5))
endfunc

// Seed the randomizer with the timer
func randomize2()
	srand(time())
endfunc

// Returns an integer from 1 to iSpread
func int get_rand(iSpread;int)
	return((rand() mod iSpread) + 1)
endfunc

//--------------
// startrekでは現在のカーソル位置にタッチキーを表示する＝位置固定ではないため、setTouchKeys()は使えない

func printKeys(x;int,y;int)
//					 枠線文字はソース上半角に見えるが、表示上は全角である
//					   __  __
//					 01234567
locate(x,y+0):print "┏━┳━┳━┳━┳━┳━┳━┳━┳━┳━┳━┓"
locate(x,y+1):print "┃０┃ .┃１┃２┃３┃４┃５┃６┃７┃８┃９┃"
locate(x,y+2):print "┗━┻━┻━┻━┻━┻━┻━┻━┻━┻━┻━┛"

// タッチキー / touch key
int i=0
touchNo(inc(i))=setTouchArea(textX2Gx(x+ 2),textY2Gy(y),textX2Gx(xw),textY2Gy(3),'0' ,YES, 125,0,5,100)
touchNo(inc(i))=setTouchArea(textX2Gx(x+ 6),textY2Gy(y),textX2Gx(xw),textY2Gy(3),'.' ,YES, 125,0,5,100)
touchNo(inc(i))=setTouchArea(textX2Gx(x+10),textY2Gy(y),textX2Gx(xw),textY2Gy(3),'1' ,YES, 125,0,5,100)
touchNo(inc(i))=setTouchArea(textX2Gx(x+14),textY2Gy(y),textX2Gx(xw),textY2Gy(3),'2' ,YES, 125,0,5,100)
touchNo(inc(i))=setTouchArea(textX2Gx(x+18),textY2Gy(y),textX2Gx(xw),textY2Gy(3),'3' ,YES, 125,0,5,100)
touchNo(inc(i))=setTouchArea(textX2Gx(x+22),textY2Gy(y),textX2Gx(xw),textY2Gy(3),'4' ,YES, 125,0,5,100)
touchNo(inc(i))=setTouchArea(textX2Gx(x+26),textY2Gy(y),textX2Gx(xw),textY2Gy(3),'5' ,YES, 125,0,5,100)
touchNo(inc(i))=setTouchArea(textX2Gx(x+30),textY2Gy(y),textX2Gx(xw),textY2Gy(3),'6' ,YES, 125,0,5,100)
touchNo(inc(i))=setTouchArea(textX2Gx(x+34),textY2Gy(y),textX2Gx(xw),textY2Gy(3),'7' ,YES, 125,0,5,100)
touchNo(inc(i))=setTouchArea(textX2Gx(x+38),textY2Gy(y),textX2Gx(xw),textY2Gy(3),'8' ,YES, 125,0,5,100)
touchNo(inc(i))=setTouchArea(textX2Gx(x+42),textY2Gy(y),textX2Gx(xw),textY2Gy(3),'9' ,YES, 125,0,5,100)
touchallcnt= i

setFunctionKey(0,"BS"   ,BS)
setFunctionKey(1,"Enter",CR)
setFunctionKey(2,"ESC"  ,ESC)
setFunctionKeyBackgroundImage("funcBackM1.png")
displayFunctionKey(YES,0,2)

endfunc

func removeAllToushArea()
	int i
	for i=1 to touchallcnt
		removeTouchArea(touchNo(i))
	next
endfunc

func float inputNumber(mes;str)
// inputを使うとキーボードに隠れて画面が見えなくなるので専用入力関数を作った
	print mes;
	int x=pos(),y
	// キーボード＋入力行分の行を空ける
	print:print:print:print
	y=csrlin()-4:// 入力行位置＝メッセージの行
	printKeys(0,y+1):// メッセージの１つ下の行からのキーを表示
	int ky,fperiod=NO
	str inp=""
	repeat
		repeat
			ky=inkey()
		until ky<>0
		switch ky
			case BS
				if right$(inp,1)="." then fperiod=NO:// '.'を消す
				inp=left$(inp,len(inp)-1)
				locate(x,y):printCtrlCode(DISP_CTRL_CLEARLINE):print inp
				break
			case ESC
			case CR
				break
			case '.'
				if fperiod=YES then {
					// すでに'.'は入力済みなので弾く
					beep()
					break
				}
				// 初入力
				fperiod=YES
			default
				if (ky>='0' and ky<='9') or ky='.' then {
					inp=inp+chr$(ky)
					locate(x,y):printCtrlCode(DISP_CTRL_CLEARLINE):print inp
				}
				break
		endswitch
	until ky=CR or ky=ESC
	removeAllToushArea()
	printCtrlCode(DISP_CTRL_CLEAR_EOS)
//	debugPrint(inp)
	float ret=val(inp)
	if ky=ESC then ret=-1
	return (ret)
endfunc

// 表示がファンクションキーにかぶるとき、スクロールして見えるようにする
func printWithScrollUp()
	print
	if csrlin()>=WY-1 then print:locate(0,WY-2)
endfunc
